// UI
#version 460
 #extension GL_EXT_multiview : enable
#define VIEW gl_ViewIndex

const vec2 _19[4] = vec2[](vec2(0.0, 1.0), vec2(0.0), vec2(1.0), vec2(1.0, 0.0));

struct StretchPic
{
    float x;
    float y;
    float w;
    float h;
    float s;
    float t;
    float w_s;
    float h_t;
    uint color;
    uint tex_handle;
};


// Vk3DVision (http://3dsurroundgaming.com/) - Stereo Injection
struct Vk3DStereo
{
	vec4 stereo;
	vec4 custom_params;
};
layout(set = 0, binding = 10, std140) uniform Vk3DParams
{
	Vk3DStereo vk3d_params[2];
};

layout(set = 0, binding = 0, std430) buffer SBO
{
    StretchPic stretch_pics[];
} _27;

layout(location = 0) out vec4 color;
layout(location = 2) out vec2 tex_coord;
layout(location = 1) flat out uint tex_id;

void main()
{
    StretchPic _36;
    _36.x = _27.stretch_pics[gl_InstanceIndex].x;
    _36.y = _27.stretch_pics[gl_InstanceIndex].y;
    _36.w = _27.stretch_pics[gl_InstanceIndex].w;
    _36.h = _27.stretch_pics[gl_InstanceIndex].h;
    _36.s = _27.stretch_pics[gl_InstanceIndex].s;
    _36.t = _27.stretch_pics[gl_InstanceIndex].t;
    _36.w_s = _27.stretch_pics[gl_InstanceIndex].w_s;
    _36.h_t = _27.stretch_pics[gl_InstanceIndex].h_t;
    _36.color = _27.stretch_pics[gl_InstanceIndex].color;
    _36.tex_handle = _27.stretch_pics[gl_InstanceIndex].tex_handle;
    StretchPic sp = _36;
    vec2 pos = (_19[gl_VertexIndex] * vec2(sp.w, sp.h)) + vec2(sp.x, sp.y);
    color = unpackUnorm4x8(sp.color);
    color = pow(color, vec4(2.400000095367431640625));
    tex_coord = vec2(sp.s, sp.t) + (_19[gl_VertexIndex] * vec2(sp.w_s, sp.h_t));
    tex_id = sp.tex_handle;
    gl_Position = vec4(pos, 0.0, 1.0);
    if (gl_Position.x < -0.2 || gl_Position.x > 0.2 ||
        gl_Position.y < -0.2 || gl_Position.y > 0.2)
    	gl_Position.x += vk3d_params[VIEW].stereo.x * vk3d_params[VIEW].custom_params.y;
    else
	    gl_Position.x += vk3d_params[VIEW].stereo.x * vk3d_params[VIEW].custom_params.x;
    
}



